/* Intercept messages to the system tray window */

#include "BBBalloon.h"




#define SHARED(X) X __attribute__((section(".BBBalloonHookSharedData"),shared))

static HMODULE g_Module = NULL;
static HHOOK SHARED(g_Hook) = NULL;
static HWND SHARED(g_SystemTray) = NULL;
static HWND SHARED(g_Reciver) = NULL;
static UINT SHARED(g_CallbackMessage);




/* BUGS: What should we do when the system tray is destroyed? */
static LRESULT CALLBACK
_BBBalloonHook_Proc(int ncode, WPARAM wp, LPARAM lp)
{
	if (ncode == HC_ACTION) {
	  CWPSTRUCT* cwps = (CWPSTRUCT*)lp;

	  if ((cwps->hwnd == g_SystemTray) && (cwps->message == WM_COPYDATA)) {
	    COPYDATASTRUCT* cds = (COPYDATASTRUCT*)(cwps->lParam);

	    if (cds->dwData == 1) {
	      DWORD action;
	      NOTIFYICONDATA* nid;

	      action = *(DWORD*)(((BYTE*)(cds->lpData)) + 4);
	      nid = (NOTIFYICONDATA*)(((BYTE*)(cds->lpData)) + 8);
	      SendMessage(g_Reciver, g_CallbackMessage, action, (LPARAM)nid);
	   }
	  }
	}
	return CallNextHookEx(g_Hook, ncode, wp, lp);
}




__declspec(dllexport) BOOL
BBBalloonHook_Begin(HWND system_tray, HWND receiver, UINT callback_message)
{
	if (g_Module == NULL) return FALSE;
	if (g_Hook != NULL) return FALSE;

	g_Hook = SetWindowsHookEx(
	           WH_CALLWNDPROC, _BBBalloonHook_Proc, g_Module,
	           GetWindowThreadProcessId(system_tray, NULL)
	         );
	if (g_Hook == NULL) return FALSE;

	g_SystemTray = system_tray;
	g_Reciver = receiver;
	g_CallbackMessage = callback_message;
	return TRUE;
}




__declspec(dllexport) BOOL
BBBalloonHook_End(void)
{
	BOOL result;

	if (g_Hook == NULL) return FALSE;

	result = UnhookWindowsHookEx(g_Hook);
	g_Hook = NULL;
	/* g_CallbackMessage = ... */
	g_Reciver = NULL;
	g_SystemTray = NULL;
	return result != 0;
}




BOOL WINAPI
DllMain(HINSTANCE dll_instance, DWORD reason, LPVOID reserved)
{
	if (reason == DLL_PROCESS_ATTACH) {
		g_Module = dll_instance;
		DisableThreadLibraryCalls(dll_instance);
	} else if (reason == DLL_PROCESS_DETACH) {
		BBBalloonHook_End();
	}

	return TRUE;
}




/* __END__ */
