#ifndef _BBB_MISC_H
#define _BBB_MISC_H

#ifdef __GNUC__
#define PRINTF_LIKE(string_index, first_to_check) \
        __attribute__((format(printf, string_index, first_to_check)))
#else
#define PRINTF_LIKE(string_index, first_to_check)
#endif

#define NUMBER_OF(array) (sizeof(array) / sizeof((array)[0]))




typedef struct {
	const char* string;
	int length;
} Token;




BOOL is_2k_or_later(void);

BOOL get_file_path(char*, int, const char*, HMODULE);

char* my_strndup(const char*, int);
int my_strncmp(const char*, const char*, int);
void tokenize(const char*, int, Token [], int*, const char**);
void descape(char*);
int my_atoi(const char*, int);
void translate_wcs_to_acs(char*, int, LPCWSTR);

#endif
