/*
 ============================================================================

  This program is free software, released under the GNU General Public License
  (GPL version 2 or later). See for details:

  http://www.fsf.org/licenses/gpl.html

  This program is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
  or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License
  for more details.

 ============================================================================
*/

#ifdef _MSC_VER
  #ifdef BBOPT_STACKDUMP
    #define TRY if (1)
    #define EXCEPT if(0)
  #else
    #define TRY _try
    #define EXCEPT _except(1)
  #endif
  #define stricmp _stricmp
  #define strnicmp _strnicmp
  #define memicmp _memicmp
  #define strlwr _strlwr
  #define strupr _strupr
#else
  #undef BBOPT_STACKDUMP
#endif

#ifndef __BBMEMO_H
#define __BBMEMO_H

#ifndef magicDWord
#define magicDWord		0x49474541
#endif

#ifndef _WIN32_WINNT
#define _WIN32_WINNT 0x0501
#endif

#include <windows.h>
#include <windowsx.h>
#include <shlwapi.h>
#include <commctrl.h>
#include <tchar.h>
#include "BBApi.h"

#ifndef SLIT_ADD
#define SLIT_ADD 11001
#endif

#ifndef SLIT_REMOVE
#define SLIT_REMOVE 11002
#endif

#ifndef SLIT_UPDATE
#define SLIT_UPDATE 11003
#endif

#ifndef WS_EX_LAYERED
#define WS_EX_LAYERED	0x00080000
#define LWA_COLORKEY	0x00000001
#define LWA_ALPHA	0x00000002
#endif

#define MAXPATH 80

//===========================================================================

HINSTANCE hInstance;
HWND hwndPlugin, hwndBlackbox, hEdit;

bool inSlit = false;
HWND hSlit = NULL;

int msgs[] = {BB_RECONFIGURE, BB_REDRAWGUI, BB_BROADCAST, 0};

char rcpath[MAX_PATH];
char stylepath[MAX_PATH];

int xpos, ypos;
int width, height;
int edgeSize;
int alpha;
int fontHeight;
int styleType;
bool alwaysOnTop;
bool snapWindow;
bool transparency;
bool pluginToggle;
bool showBorder;
bool showScroll;
bool lockPos;
bool wordWrap;

bool usingWin2kXP;
OSVERSIONINFO  osvinfo;

HDC hdc;
HBITMAP bufbmp;
HFONT hEditFont;
HBRUSH hBrush;

char fontFace[256];
int fontSize;
COLORREF fontColor;
COLORREF backColor;

void ShowMyMenu(bool popup);
void SetWindowModes(void);
void OnPaint(HWND hwnd);
StyleItem myStyleItem;
int bevelWidth;
int borderWidth;
COLORREF borderColor;

Menu *myMenu, *configSubmenu, *settingsSubmenu,  *styleSubmenu,
*formatSubmenu, *fontSubmenu, *hMenu;

char textPath[MAX_LINE_LENGTH];
char *szTemp;

int ScreenWidth;
int ScreenHeight;

int newWidth;
int newHeight;

//===========================================================================

LRESULT CALLBACK WndProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK EditProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam);
WNDPROC oldEditProc;
BOOL WINAPI BBSetLayeredWindowAttributes(HWND hwnd, COLORREF crKey, BYTE bAlpha, DWORD dwFlags);

void GetStyleSettings();
void ReadRCSettings();
void WriteRCSettings();

//===========================================================================

bool ResizeMyWindow(int newWidth, int newHeight);

char szStr[1024 * 32];
void ReadTextFile();
void WriteTextFile();
void SetWordWrap();

bool window_test_autohide(POINT *pt);
bool autoHide;
bool is_autohidden;
bool is_focus;

#define AUTOHIDE_TIMER 1
#define AUTOSAVE_TIMER 2
#define AUTOHIDE_DELAY 300

bool autoSave;
int saveInterval;

//===========================================================================

extern "C"
{
	__declspec(dllexport) LPCSTR pluginInfo(int field);
	__declspec(dllexport) void endPlugin(HINSTANCE hMainInstance);
	__declspec(dllexport) int beginPlugin(HINSTANCE hMainInstance);
	__declspec(dllexport) int beginSlitPlugin(HINSTANCE hMainInstance, HWND hBBSlit);
	__declspec(dllexport) int beginPluginEx(HINSTANCE hMainInstance, HWND hBBSlit);
}

//===========================================================================

#endif
