/*
 ============================================================================
 Blackbox for Windows: Plugin SDK example used for making this plugin
 ============================================================================
 Copyright  2001-2002 The Blackbox for Windows Development Team
 http://desktopian.org/bb/ - #bb4win on irc.freenode.net
 ============================================================================

  Blackbox for Windows is free software, released under the
  GNU General Public License (GPL version 2 or later), with an extension
  that allows linking of proprietary modules under a controlled interface.
  What this means is that plugins etc. are allowed to be released
  under any license the author wishes. Please note, however, that the
  original Blackbox gradient math code used in Blackbox for Windows
  is available under the BSD license.

  http://www.fsf.org/licenses/gpl.html
  http://www.fsf.org/licenses/gpl-faq.html#LinkingOverControlledInterface
  http://www.xfree86.org/3.3.6/COPYRIGHT2.html#5

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  GNU General Public License for more details.

  For additional license information, please read the included license.html

 ============================================================================
*/

#include <stdio.h>
//windows 9x must have Windows Socket 2 upgrade and Microsoft DUN 1.3 for year 2000 compliance
#include <WinSock.h>
#include <string.h>
#include <stdio.h>
#include <Math.h>
#include <Shlwapi.h>
#include <AggressiveOptimize.h>

#include "getStats.h"
#include "../../blackbox/BBApi.h"
#include "Resource.h"

//#pragma comment(lib, "../includes/Blackbox.lib")
//#pragma comment(lib, "Psapi.Lib")
//#pragma comment(lib, "WS2_32.Lib")
//#pragma comment(lib, "SHLWAPI.LIB")
//#pragma comment(lib, "Kernel32.lib")
//#pragma comment(lib, "wsock32.lib")
//#pragma comment(lib, "MessageBox.lib")
//#pragma warning(disable: 4786) // disable STL naming warnings when compiling
//#pragma warning(disable: 4089)

#ifndef __BBSYSMON_H
#define __BBSYSMON_H

#ifndef magicDWord
#define magicDWord		0x49474541
#endif

//xoblite stuff
#ifndef PLUGIN_NAME
#define PLUGIN_NAME			1		// pluginInfo
#endif
#ifndef PLUGIN_VERSION
#define PLUGIN_VERSION		2
#endif
#ifndef PLUGIN_AUTHOR
#define PLUGIN_AUTHOR		3
#endif
#ifndef PLUGIN_RELEASEDATE
#define PLUGIN_RELEASEDATE	4
#endif
#ifndef PLUGIN_LINK
#define PLUGIN_LINK			5
#endif
#ifndef PLUGIN_EMAIL
#define PLUGIN_EMAIL		6
#endif
#ifndef PLUGIN_BROAMS
#define PLUGIN_BROAMS		7
#endif
//end xoblite stuff

//temporary until upgrade to .9x BBAPI
#ifndef SLIT_ADD
#define SLIT_ADD 11001
#endif

#ifndef SLIT_REMOVE
#define SLIT_REMOVE 11002
#endif

#ifndef SLIT_UPDATE
#define SLIT_UPDATE 11003
#endif
//end of temp fix

#ifndef _WIN32_WINNT
#define _WIN32_WINNT 0x0500
#endif

#ifndef WS_EX_LAYERED
#define WS_EX_LAYERED	0x00080000
#define LWA_COLORKEY	0x00000001
#define LWA_ALPHA		0x00000002
#endif // ndef WS_EX_LAYERED

//#define WIN32_LEAN_AND_MEAN

//#include <windows.h>
//#include <newapis.h>

#define MAXPATH 80
#define IDT_TIMER 4500
#define IDT_DISK_TIMER 4501
#define IDT_UPTIME_TIMER 4502



//for username and computer name
#define BUFSIZE 1024

//for strlen when making a dynam,ically allocationed array
#define MAXCPUCNTRSIZE 5	//counts a '\0' at the end
//#define MAXRAMCNTRSIZE 5	//same as above
#define MAXUPTIMECNTRSIZE 25	//good size just in case
#define MAXDRIVECOUNTERSIZE 16

// for drive space
#define COMPILE_NEWAPIS_STUBS
#define WANT_GETDISKFREESPACEEX_WRAPPER

//===========================================================================


HINSTANCE hInstance;
HWND hwndBBSysMon, hwndBlackbox;
bool inSlit = false;	//Are we loaded in the slit? (default of no)
HWND hSlit = NULL;				//The Window Handle to the Slit (for if we are loaded)

// Blackbox messages we want to "subscribe" to:
// BB_RECONFIGURE -> Sent when changing style and on reconfigure
// BB_BROADCAST -> Broadcast message (bro@m)
int msgs[] = {BB_RECONFIGURE, BB_BROADCAST, 0};

char rcpath[MAX_PATH];
char stylepath[MAX_PATH];

//some rc settings
int xpos, ypos;
int width, height;
bool alwaysOnTop;
int alpha;
bool snapWindow;
bool transparency;
int slitMode;
bool wantInSlit;
char windowStyle[24];
COLORREF textColor;
int fontHeight;
char rcFont[256];
DWORD justify;
bool autoResize;
bool padPercentages;
char strFormat[MAX_LINE_LENGTH];
bool BBSysMonPluginToggle;
//char BBSysMonPlacement[MAX_LINE_LENGTH];
//int BBSysMonWidthPercent;

bool useRCFontHeight = false;
bool useRCFontColor = false;
bool useRCFont = false;

//for resolution checks
int ScreenWidth;
int ScreenHeight;

//for style settings
COLORREF backColor;
COLORREF backColorTo;
COLORREF backColor2;
COLORREF backColorTo2;
char fontFace[256];
int fontSize;
COLORREF fontColor;


StyleItem *myStyleItem;
StyleItem *myStyleItem2;
bool labelIsPR;
int bevelWidth;
int borderWidth;
COLORREF borderColor;

Menu *myMenu, *configSubmenu, *settingsSubmenu,
 *placementSubmenu, *windowStyleSubmenu, *justifySubmenu;



//DWORD           ctrType;

char counterText[MAX_LINE_LENGTH];
char displayString[MAX_LINE_LENGTH];
int	updateInterval;

//===========================================================================

enum opSys {OPSYS_WIN_9X,
            OPSYS_WIN_NT4,
            OPSYS_WIN_NT5};

CGetStats*  m_pStatsObj;


enum opSys  m_eOpSys;


//============================================================
//Mortar's adds
//Ticker for uptime, probably should be in a struct, sometime :)
//DWORD ticker;

LPTSTR compName;      // pointer to computer name information string 
LPTSTR userName;      // pointer to user name information string
//LPTSTR lpszSystemInfo;      // pointer to system information string
DWORD cchBuff = BUFSIZE;    // size of computer or user name
TCHAR tchBuffer[BUFSIZE];  //temp char buffer

DWORD cchBuff2 = BUFSIZE;    // size of computer or user name
TCHAR tchBuffer2[BUFSIZE];  //temp char buffer

ULONGLONG drSpaceBytes;
LPCTSTR dirSize;			//null terminated string that specifies the dir of interest.  
							//If null then root is used.  UNC must have traling /example "//netpath/dir/"

UINT iCPUPercent;
UINT iSwapMemPercent;
UINT iPhysMemPercent;
//bool bInvalidateRect = false;
//UINT iBATPercent;
//bool bACOnline;
//bool bBATCharging;

static char szTemp[MAX_LINE_LENGTH];

//CString strTemp;
//===========================================================================

LRESULT CALLBACK WndProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam);
BOOL WINAPI BBSetLayeredWindowAttributes(HWND hwnd, COLORREF crKey, BYTE bAlpha, DWORD dwFlags);

void GetStyleSettings();
void ReadRCSettings();
void WriteRCSettings();

DWORD      dwId;
DWORD      dwMajorVer;
DWORD      dwMinorVer;

int WINAPI _GetPlatformId(DWORD *pdwId, DWORD *pdwMajorVer, DWORD *pdwMinorVer);

//get byte of a drive added - Mortar
ULONGLONG GetDiskFreeSpaceBytes(LPCTSTR szDrive);

//my get ip
char* mLocalhost;
void mgetIp();

//void resizeWindow();

void InitBBSysMon();

//===========================================================================
// Menu and placement variables
void ShowMyMenu();

//draw the text mode
void drawTextMode(HWND hwnd);

//gets the values of counters that don't change
void getStaticCounters();

//===========================================================================
//process intput string strFormat
void processInputString();
void processExtendedChar();
bool useNewLine;
void cleanParser();
void initParser();
void makeDisplayString();
void setDriveSpaces();
void setUptime();
void setMainTimerValues();
bool resizeMyWindow(int newWidth, int newHeight); //returns true if the window is resized
char* getStringInfo(char* strptr, int* xsize, int* ysize); //returns a pointer to the longest string on one line


int newArrayPos;
char* tokenString[100];
int currentPos;
int numOfCounters;
int numOfRegStrings;
int numOfDriveCounters;
int cpuCntrPtrPos;
int ramCntrPtrPos;
int swapCntrPtrPos;
int nameCntrPtrPos;
int workstationCntrPtrPos;
int ipCntrPtrPos;
int dirCntrPtrPos[26];
int uptimeCntrPos[3];	//4 uptime counters, but hours and minutes must allays be shown

//bool for the smart padder/string formatter
/*
bool useGBUnits;
bool padPercentages;
bool padDriveSpaces;
bool padUptimes;
bool padIP;
//bool padSwap;
//bool padBat;
char padChar[1];
int workStationMaxSize;
int nameMaxSize;
*/

//===========================================================================
//set the screen position
//void setScreenPosition();
//bool bBackgroundExists;

//===========================================================================

extern "C"
{
	__declspec(dllexport) LPCSTR pluginInfo(int field);
	__declspec(dllexport) void endPlugin(HINSTANCE hMainInstance);
	__declspec(dllexport) int beginPlugin(HINSTANCE hMainInstance);
	__declspec(dllexport) int beginSlitPlugin(HINSTANCE hMainInstance, HWND hBBSlit);
	__declspec(dllexport) int beginPluginEx(HINSTANCE hMainInstance, HWND hBBSlit);
}



//===========================================================================

#endif
