//parseTest.cpp
//Initialization of a Pre-Specified Control String to a dynamic array for later updating on a continous output stream.
//(c)2003 Brad Bartolucci

#include <windows.h>
#include <stdio.h>
#include <string.h>

//Parses a input string by a token seperator char (i.e. %), that could be used for for setting up some string pointers
//based on the identifier specified after the seperator, (i.e. string%Cstring%Rstring%D)
//This example is for a system information counter

//tabs and newlines are not prossed here, they are read as either one char (new line) or two chars ('\''n').  It does not effect this.

//%C	cpu % used---someone expressed an interest for more than 1 CPU, maybe will add sometime
//%R	ram % used
//%DA-Z	drive space availible
//%N	name of the user
//%W	workstation name
//%UW	weeks is master uptime counter i.e. 0w 0d 0h 0m-----|
//%UD	days is master uptime counter i.e. 0d 0h 0m			|- can only use one of three possible states
//%UH	hours is master uptime counter i.e. 0h 0m-----------|
//%P	ip address---possibly add %P1-5 for showing 1-5 ip's.

void main()
{
	char strFormat[] = "%N@%W\\n\\nCPU:\\t%C\\nRAM:\\t%R\\nIP:\\t%P\\nC:\\\t%DC\\nZ:\\\t%DZ\\nUptime:\\t%UH";
	char temp[1024];			//actually should be [MAXSTRINGLENGTH]
	strcpy(temp, strFormat);	//seems strFormat gets changed when it is strtok()ed.  So we let it mess with a temp copy.
	char* pch;					//Our token pointer

	char* tokenString[100];
	for(int i = 0; i < 100; i++)	//initialize the pointer array
		tokenString[i] = NULL;

	int currentPos = 0;			//for counting along with the token pointer of strtok()
	int newArrayPos = 0;		//pointer position in an array to a new dynamically allocated string.  Also acts a a counter.
	int trim = 0;				//Some identifiers are different sizes, so we need a trim condition.

	int numOfCounters = 0;		//Count number of counters.  Always handy to have for the future
	int numOfRegStrings = 0;	//Count regular strings, not counting token strings that only have an identifier character.
	int numOfDriveCounters = 0; //initialize a drive Letter counter
	int cpuCntrPtrPos = -1;		//initilize all counter positions to -1.
	int ramCntrPtrPos = -1;		//Quick note to self: May have to pad the dynString and make it the size MaxPossibleSizeOfCpuCounter 
	int nameCntrPtrPos = -1;	//which is 4(5 including the '\0' terminator) i.e. %100. That is just the cpu counter max size.
	int workstationCntrPtrPos = -1;
	int ipCntrPtrPos = -1;
	
	int dirCntrPtrPos[26];
	for(int i = 0; i < 26; i++)		//initialize all the drive positions to -1.
		dirCntrPtrPos[i] = -1;
	int uptimeCntrPos[3];
	for(int i = 0; i < 3; i++)		//initialize all uptime positions to -1. pos[0] = weeks, pos[1] = days, pos[2] = hours
		uptimeCntrPos[i] = -1;

	//Should create a new string pointer of appropriate size where ever newArrayPos is found, replaceing the above printf.
	//Store the pointer in a pointer array like char* displayStrPtr[100].  The pointer is save to displayStrPtr[newArrayPos] before the ++.
	printf("\n");
	//special case:  when a token is on the left side of the % sign,
	//which can only happen at the beginning of the input string.
	pch = strtok(temp, "%");		//get first token for loop
	if(strFormat[0] != '%')
	{
		currentPos = currentPos + strlen(pch);
		printf(pch);
		tokenString[newArrayPos] =  new char[strlen(pch) + 1];
		strcpy(tokenString[newArrayPos], pch);
		newArrayPos++;
		numOfRegStrings++;
		pch = strtok (NULL, "%");		//get the next token for the loop
	}
	
	//Now we treat every token as if they are on the right side of the percent sign
	//There is always a token on the right, sometimes it is only the identifier though.  :)
	while (pch != NULL)
	{
		if(strFormat[currentPos + 1] == 'C')			//CPU Counter Found
		{
			if(cpuCntrPtrPos == -1)
			{
				printf("Cfound->");
				numOfCounters++;
				cpuCntrPtrPos = newArrayPos;
				tokenString[newArrayPos] =  new char[strlen("[Ccntr]") + 1];
				strcpy(tokenString[newArrayPos], "[Ccntr]");	//this will not need to be copied, actually make equal to \0
				newArrayPos++;									//the counters will be updated to the dynamic string in another function
			}											//just make it the size of the MAXCPUCOUNTERSIZE for example
			trim = 1;
		}
		else if(strFormat[currentPos + 1] == 'D')	//Directory found, only if a dir A-Z if specified.  Case sensitive.
		{
			if((strFormat[currentPos + 2] >= 65) && (strFormat[currentPos + 2] <= 90))	//A-Z or 65 to 90.  Brad's [Mortar] handy dandy ascii trick
			{
				if(dirCntrPtrPos[strFormat[currentPos + 2] - 65] == -1)
				{
					printf("Dfound->");
					numOfCounters++;
					dirCntrPtrPos[strFormat[currentPos + 2] - 65] = newArrayPos;		//Some more ascii fun, look closely.  (hint..What is the value of strFormat[currentPos + 2] here?)
					tokenString[newArrayPos] =  new char[strlen("[Dircntr]") + 1];
					strcpy(tokenString[newArrayPos], "[Dircntr]");
					newArrayPos++;
					numOfDriveCounters++;
				}
				trim = 2;
			}
			else
				trim =1;
		}
		else if(strFormat[currentPos + 1] == 'N')	//Name of user Counter Found
		{
			if(nameCntrPtrPos == -1)
			{
				printf("Nfound->");
				numOfCounters++;
				nameCntrPtrPos = newArrayPos;
				tokenString[newArrayPos] =  new char[strlen("[Ncntr]") + 1];
				strcpy(tokenString[newArrayPos], "[Ncntr]");
				newArrayPos++;
			}
			trim = 1;
		}
		else if(strFormat[currentPos + 1] == 'P')	//IP Counter Found
		{
			if(ipCntrPtrPos == -1)
			{
				printf("Pfound->");
				numOfCounters++;
				ipCntrPtrPos = newArrayPos;
				tokenString[newArrayPos] =  new char[strlen("[Pcntr]") + 1];
				strcpy(tokenString[newArrayPos], "[Pcntr]");
				newArrayPos++;
			}
			trim = 1;
		}
		else if(strFormat[currentPos + 1] == 'R')	//RAM Counter Found
		{
			if(ramCntrPtrPos == -1)
			{
				printf("Rfound->");
				numOfCounters++;
				ramCntrPtrPos = newArrayPos;
				tokenString[newArrayPos] =  new char[strlen("[Rcntr]") + 1];
				strcpy(tokenString[newArrayPos], "[Rcntr]");
				newArrayPos++;
			}
			trim = 1;
		}
		else if(strFormat[currentPos + 1] == 'U')	//Uptime Counter Found
		{
			if((strFormat[currentPos + 2] == 'W') || (strFormat[currentPos + 2] == 'D') || (strFormat[currentPos + 2] == 'H'))
			{
				if((uptimeCntrPos[0] == -1) && (uptimeCntrPos[1] == -1) && (uptimeCntrPos[2] == -1))
				{
					printf("Ufound->");
					numOfCounters++;
					if(strFormat[currentPos + 2] == 'W')
						uptimeCntrPos[0] = newArrayPos;	//weeks is master counter
					else if(strFormat[currentPos + 2] == 'D')
						uptimeCntrPos[1] = newArrayPos; //days is master counter
					else
						uptimeCntrPos[2] = newArrayPos; //hours is master counter

					tokenString[newArrayPos] =  new char[strlen("[Upcntr]") + 1];
					strcpy(tokenString[newArrayPos], "[Upcntr]");
					newArrayPos++;
				}
				trim = 2;
			}
			else
				trim = 1;
		}
		else if(strFormat[currentPos + 1] == 'W')	//Workstation Counter Found
		{
			if(workstationCntrPtrPos == -1)
			{
				printf("Wfound->");
				numOfCounters++;
				workstationCntrPtrPos = newArrayPos;
				tokenString[newArrayPos] =  new char[strlen("[Wcntr]") + 1];
				strcpy(tokenString[newArrayPos], "[Wcntr]");
				newArrayPos++;
			}
			trim = 1;
		}


		if (trim != 0)
			{
			if((strlen(pch) - trim) > 0 )	//if there are more characters and an identifier, trim and save the string
				{
					printf(pch);
					tokenString[newArrayPos] =  new char[(strlen(pch) + 1)];
					strcpy(tokenString[newArrayPos], pch);
					for(int i = 0; i < (strlen(pch) - trim); i++)	//get the clipper and start trimming, or shift the characters left
						tokenString[newArrayPos][i] = tokenString[newArrayPos][i + trim];
					tokenString[newArrayPos][strlen(pch) - trim] = NULL;	//make sure there is a NULL at the end
					newArrayPos++;
					numOfRegStrings++;
				}
			else							//this is only needed for displaying a lonely identifier, will not need a new arrayposition here.
				printf(pch);				//else save nothing
		}
		else								//save the string even if identifier is not found in the token
		{
			printf(pch);
			tokenString[newArrayPos] =  new char[strlen(pch) + 1];
			strcpy(tokenString[newArrayPos], pch);
			newArrayPos++;
			numOfRegStrings++;
		}

		currentPos++;					//add 1 because a % sign was found, and it is removed
		trim = 0;						//reset the trim size back to 0
		currentPos = currentPos + strlen(pch);	//keep counting along with the token ponter
		pch = strtok (NULL, "%");		//get next token
	}

	
	int i = 0;
	//useNewLine = false;	//currently false
	strcpy(temp, "\0");
	while(tokenString[i] != NULL)
	{
		currentPos = 0;
		sprintf(temp, "%s", tokenString[i]);
		pch = strtok(temp, "\\");		//get first token for loop
		if(tokenString[i][0] != '\\')
		{
			currentPos = currentPos + strlen(pch);
			pch = strtok (NULL, "\\");		//get the next token for the loop
		}
		while(pch != NULL)
		{
			if(tokenString[i][currentPos + 1] == '\\')
			{
				currentPos++;
				while((currentPos != strlen(tokenString[i]) - 1) && (tokenString[i][currentPos + 1] == '\\'))
					currentPos++;
			}
			
			if(tokenString[i][currentPos + 1] == 't')
			{
				tokenString[i][currentPos] = '\t';
				tokenString[i][currentPos + 1] = ' ';
			}
			else if(tokenString[i][currentPos + 1] == 'n')
			{
				tokenString[i][currentPos] = '\r';
				tokenString[i][currentPos + 1] = '\n';
				//useNewLine = true;
			}

			currentPos++;
			currentPos = currentPos + strlen(pch);
			pch = strtok (NULL, "\\");
		}
		i++;
	}





	//print some output
	printf("\n\nNumber of Counters:  %i", numOfCounters);
	printf("\nNumber of Regular strings:  %i", numOfRegStrings);
	printf("\n\nCpu counter:  %i", cpuCntrPtrPos);
	printf("\nRam counter:  %i", ramCntrPtrPos);
	
	int d = numOfDriveCounters;			//loop through the whole alphabet or as many drive counters found
	for(int c = 0; (c < 26) && (d > 0); c++)
	{
		if(dirCntrPtrPos[c] != -1)
		{
			d--;
			printf("\nDrive%c counter:  %i\n", (c + 65), dirCntrPtrPos[c]); //65 is ascii for A
		}
	}
	//print and delete all of our string pointers
	printf("\n");
	for(int i = 0; i < newArrayPos; i++)
	{
		printf("%s", tokenString[i]);
		delete [] tokenString[i];
		tokenString[i] = NULL;
	}
	printf("\n");

}
